window.renderAgent = new function () {           
       var me=this;
       this._eventLookup = {};
       
       this.video = new function () {
        
       };
       
       this.ui = new function () {
        
       };
       
       function bindProperty(targetObject, propertyName, getMethodName, setMethodName) {
              if (!setMethodName) {
                     Object.defineProperty(targetObject, propertyName, {
                           get: function () {
                                  return _renderAgent[getMethodName]();
                           }
                     });
              } else {
                     Object.defineProperty(targetObject, propertyName, {
                           get: function () {
                                  return _renderAgent[getMethodName]();
                           },
                           set: function (param) {
                                  return _renderAgent[setMethodName](param);
                           }
                     });
              }
       }
             
    bindProperty(this.video, "framesPerSecondNominal", "getFramesPerSecondNominal");
    bindProperty(this.video, "framesPerSecond", "getFramesPerSecond");
    bindProperty(this.video, "frameDrops", "getFrameDrops");
    bindProperty(this.video, "frameDropsPerSecond", "getFrameDropsPerSecond");
       
    bindProperty(this.ui, "framesPerSecond", "getUIFramesPerSecond");
      
    this._fireEvent = function (eventName, payload) {
         if (this._eventLookup[eventName]) {
            this._eventLookup[eventName].forEach(function (callback) {
                callback(payload);
            });
        }
    };
       
    this.addEventListener = function (eventName, callback) {
        if (!this._eventLookup[eventName]) {
            this._eventLookup[eventName] = [];
        }
        this._eventLookup[eventName].push(callback);
    };

    this.removeEventListener = function (eventName, callback) {
        if (this._eventLookup[eventName]) {
            this._eventLookup[eventName] = this._eventLookup[eventName].filter(function (value) { return value !== callback; });
        }
    };
};
